/*
Program: all-pairs-shortest-path-v1.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: @Floyd-WarshalltkAHѪshortestPath.datɮק@J 
Notes: 
	1) Floyd-WarshalltkuʺAWv(dynamic programming)k
	2) ŪƩҥε{XۮѪshortestPath.cվ禡쫬(prototype)BץΥܼ 
	3) Ѧ https://www.geeksforgeeks.org/floyd-warshall-algorithm-dp-16/
	   P https://www.programiz.com/dsa/floyd-warshall-algorithm 
*/

#include <stdio.h>
#include <stdlib.h>	/* for exit() */

#define MAX_V 		100			/* ̤jI */
#define Inf 		1073741823	/* 2^30-1jƦrA{]LjȡFilimits.hwqINT_MAX */

void init(int A[][MAX_V], int Y[][MAX_V], int *N)	/* ŪJɡB]w۾Fx}AƵc@l */ 
{
    FILE *fptr;
    int  i, j;
    int  weight;

    if ((fptr=fopen("shortestPath.dat","r")) == NULL) {	/* }Ҹ */ 
        perror("shortestPath.dat");
        exit(1);
    }

    fscanf(fptr,"%d",N);		/* Ūϧθ`I */
    for (i = 1; i <= *N; i++ )
        for (j = 1; j <= *N; j++) {
            A[i][j] = (i==j)? 0: Inf;	/* lA[1..N][1..N]۾Fx}AҦw] */
            Y[i][j] = (i==j)? i: -1;
       	}
 
    while (fscanf(fptr,"%d %d %d",&i,&j,&weight) != EOF) { 
    	A[i][j] = weight;	/* ŪsIiPj䪺v */
    	Y[i][j] = i;		/* Y[i][j]w]i */ 
    } 
    
	fclose(fptr);
}

/* UfloydWarshall()禡NCGI(i,j)p̵uZȡAðOigѭǤ~IF̵u */ 
void floydWarshall(int A[][MAX_V], int Y[][MAX_V], int N) 
{
	int i, j, k;

	for (k = 1; k <= N; k++) 
    	for (i = 1; i < N; i++) 
      		for (j = 1; j <= N; j++) 
        		if (A[i][k] + A[k][j] < A[i][j]) { //if (A[i][k] != Inf && A[k][j] != Inf && A[i][k] + A[k][j] < A[i][j]) { 	
        			A[i][j] = A[i][k] + A[k][j];
					Y[i][j] = Y[k][j]; /* g Y[i][j] = k */
				}
	/* WGhforjΩץCGI(i,j)ZȡA˵_gk(@ӥi઺~I)opZ */ 
	/* 
	dNline 53gkAg Y[i][j] = kAPǥiϤtO?! 
	zѡGline 37iAYGI(i,j)sbANY[i][j]w]iC
	]Abline 53AYkPjsbAgY[k][j]PgkNqۦPANje~IkC 
	YkPjLsAh]Y[i][j] = Y[k][j]ANij̫@Ӥ~INѱqkj|ҰO̫ 
	@Ӥ~IMw(Y[k][j]ثeҪkjZj̪񪺤~I)C 
	zLline 53]mYx}eANi^o̵u|  
	*/	
}

void printMatrix(int A[][MAX_V], int N) 
{
	int i, j;
	
	printf("\n\nBoI(i,j)x}TpUG\n       ");
	for (i = 1; i <= N; i++) printf("%4d",i);
	for (i = 0; i <= N; i++) printf("%4s",i==0? "\n      +":"----");
		
  	for (i = 1; i <= N; i++) {
  		printf("\nI%d |",i);
    	for (j = 1; j <= N; j++) {
      		if (A[i][j] == Inf)
        		printf("%5s","");	/* somewhat weird to use %5s instead of %4s here */
      		else
        		printf("%4d",A[i][j]);
    	}
    	//printf("\n");
  	}
}

int backtrack(int A[][MAX_V], int Y[][MAX_V], int source, int dest) 
{
	int distance, k = Y[source][dest];	/* ksourcedest~I */ 
	
	if (source == dest) {
		printf("I%d ",source);
		return A[source][dest];
	}
	if (Y[source][dest] == -1) {
        printf("I%dP%dS|sb:(  ",source,dest);
        return Inf;
    }
    distance = backtrack(A,Y,source,k);
    printf(" %d ",dest);
    
	return distance+A[k][dest];
}

void traverseMatrix(int A[][MAX_V],int Y[][MAX_V]) 
{
	int distance, source, sink; 
	
	printf("\n\ndߥGI̵u|\nI(0hXd) => ");
    scanf("%d",&source);
    if (source == 0) return;
    printf("I(0hXd) => ");
    scanf("%d",&sink);
    if (sink == 0) return;
	
	printf("̵u|G");
	distance = backtrack(A,Y,source,sink);
	printf("\b\b (ҸgZ`M=%d)(dA[%d][%d]=%d)",distance,source,sink,A[source][sink]);	/* ٰ̫ܦhl"" */ 
}

int main() 
{
	int N, A[MAX_V][MAX_V], Y[MAX_V][MAX_V] = {0};
	/* NϩҧtI`ơFA[1..N][1..N]ϧΪ۾Fx} */
	/* Y[1..N][1..N]OGI(i,j)Zj̪񪺤~IANΩ̵u|^ */
	
	printf("\n***  all-pairs shortest-path D ***");
            
	init(A,Y,&N);			/* ŪJɡB]w۾Fx}AçƵc@l */
  	floydWarshall(A,Y,N);
  	printMatrix(A,N);
  	//printMatrix(Y,N);
  	traverseMatrix(A,Y);
	
	return 0; 
}
