/*
Program: all-pairs-shortest-path-v2.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: קall-pairs-shortest-path-v1.cϱoAPYx}̹ϤI`Ƨ@tmAקK
		wtmLj100x100}CŶӧΦO 
*/

#include <stdio.h>
#include <stdlib.h>	/* for exit() */

#define Inf 		1073741823	/* 2^30-1jƦrA{]LjȡFilimits.hwqINT_MAX */

void init(int ***A, int ***Y)	/* ŪJɡB]w۾Fx}AƵc@l */ 
{
    FILE *fptr;
    int  i, j;
    int  weight, N;

    if ((fptr=fopen("shortestPath.dat","r")) == NULL) {	/* }Ҹ */
        perror("shortestPath.dat");
        exit(1);
    }

    fscanf(fptr,"%d",&N);		/* Ūϧθ`I */
    
    *A = (int **)malloc((N+1)*sizeof(int *));
    *Y = (int **)malloc((N+1)*sizeof(int *));
    for (i = 0; i <= N; i++) {
        (*A)[i] = (int *)malloc((N+1)*sizeof(int));
        (*Y)[i] = (int *)malloc((N+1)*sizeof(int));
    }
	
    (*A)[0][0] = N;
    for (i = 1; i <= N; i++ )
        for (j = 1; j <= N; j++) {
			(*A)[i][j] = (i==j)? 0: Inf;	/* lA[1..N][1..N]۾Fx}AҦw] */
            (*Y)[i][j] = (i==j)? i: -1; 
        } 
 
    while (fscanf(fptr,"%d %d %d",&i,&j,&weight) != EOF) { 
    	(*A)[i][j] = weight;       /* ŪsIiPj䪺v */
    	(*Y)[i][j] = i;
    }
	 
	fclose(fptr);
}

void floydWarshall(int ***A, int ***Y) 
{
	int i, j, k;
	int N = (*A)[0][0]; //Lkϥsizeof(A[0])/sizeof(A[0][0])PŪסA]Hmalloc()tmұoOŶ㵲c 

	for (k = 1; k <= N; k++) 
    	for (i = 1; i <= N; i++) 
      		for (j = 1; j <= N; j++) 
        		if ((*A)[i][k] + (*A)[k][j] < (*A)[i][j]) {
					(*A)[i][j] = (*A)[i][k] + (*A)[k][j];
					(*Y)[i][j] = (*Y)[k][j];
				} 
		//WGhforjΩ˵/ץCGI(i,j)_gk(~I)opZ 	
}

void printMatrix(int **A) 
{
	int i, j;
	int N = A[0][0]; 
	
  	for (i = 1; i <= N; i++) {
    	for (j = 1; j <= N; j++) {
      		if (A[i][j] == Inf)
        		printf("%5s","");
      		else
        		printf("%4d",A[i][j]);
    	}
    	printf("\n");
  	}
}

void backtrack(int **Y, int source, int dest) 
{
	int k = Y[source][dest];
	
	if (source == dest) {
		printf("I%d ",source);
		return;
	}
	if (Y[source][dest] == -1) {
        printf("I%dP%dS|sb  ",source,dest);
        return;
    }
    backtrack(Y,source,k);
    printf(" %d ",dest);
}

void traverseMatrix(int **Y) 
{
	int i, j, k, source, sink; 
	
	printf("\nI => ");
    scanf("%d",&source);
    printf("I => ");
    scanf("%d",&sink);
	
	printf("̵u|G");
	backtrack(Y,source,sink);
	printf("\b\b  ");
}

void freeMemory(int **A, int **Y) 
{
	int i, N = A[0][0];
	
	for (i = 0; i <= N; i++) { 
		free(A[i]); 
		free(Y[i]); 
	} 
	free(A); 
	free(Y);
}

int main() {
	int **A, **Y;
            
	init(&A,&Y);			/* ŪJɡB]w۾Fx}AçƵc@l */
	floydWarshall(&A,&Y);
  	printMatrix(A);
  	traverseMatrix(Y);
  	freeMemory(A,Y);
  	
  	return 0;
}
