/*
Program: all-pairs-shortest-path-v3.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: קall-pairs-shortest-path-v2.cAsWۭqadjMatrixƫAtAPYGx}A
		x}̹ϤI`Ƨ@tmABקKϥΤThСAPǪǲ߭t 
*/

#include <stdio.h>
#include <stdlib.h>	/* for exit() */

#define Inf 		1073741823	/* 2^30-1jƦrA{]LjȡFilimits.hwqINT_MAX */

typedef struct adjMatrix {
	int **A;	/* A[][]x}AHй@ */ 
	int **Y;	/* Y[][]x}AHй@ */ 
	int size;	/* x}סAΥHܤWzGx}N NxN } */ 
} adjMatrix;

adjMatrix init()	/* ŪJɡB]w۾Fx}AƵc@l */ 
{
    FILE *fptr;
    int  i, j;
    int  weight, N;
    static adjMatrix adj;

    if ((fptr=fopen("shortestPath.dat","r")) == NULL) {	/* }Ҹ */
        perror("shortestPath.dat");
        exit(1);
    }

    fscanf(fptr,"%d",&N);		/* Ūϧθ`I */
    
    adj.A = (int **)malloc((N+1)*sizeof(int *));
    adj.Y = (int **)malloc((N+1)*sizeof(int *));
    for (i = 0; i <= N; i++) {
        adj.A[i] = (int *)malloc((N+1)*sizeof(int));
        adj.Y[i] = (int *)malloc((N+1)*sizeof(int));
    }
	
    adj.size = N;
    for (i = 1; i <= N; i++ )
        for (j = 1; j <= N; j++) {
			adj.A[i][j] = (i==j)? 0: Inf;	/* lA[1..N][1..N]۾Fx}AҦw] */
            adj.Y[i][j] = (i==j)? i: -1; 
        } 
	
    while (fscanf(fptr,"%d %d %d",&i,&j,&weight) != EOF) {
    	adj.A[i][j] = weight;       /* ŪsIiPj䪺v */
    	adj.Y[i][j] = i;
	}
    	
	fclose(fptr);
	
	return adj;
}

void floydWarshall(adjMatrix *adj) {
	int i, j, k;
	int N = adj->size; 

	for (k = 1; k <= N; k++) 
    	for (i = 1; i <= N; i++) 
      		for (j = 1; j <= N; j++) 
        		if (adj->A[i][k] + adj->A[k][j] < adj->A[i][j]) {
        			adj->A[i][j] = adj->A[i][k] +adj->A[k][j];
        			adj->Y[i][j] = adj->Y[k][j];
				} 	
}

void printMatrix(adjMatrix *adj) 
{
	int i, j, N = adj->size;
	
	printf("\n\nBoI(i,j)x}TpUG\n       ");
	for (i = 1; i <= N; i++) printf("%4d",i);
	for (i = 0; i <= N; i++) printf("%4s",i==0? "\n      +":"----");
		
  	for (i = 1; i <= N; i++) {
  		printf("\nI%d |",i);
    	for (j = 1; j <= N; j++) {
      		if (adj->A[i][j] == Inf)
        		printf("%5s","");	/* somewhat weird to use %5s instead of %4s here */
      		else
        		printf("%4d",adj->A[i][j]);
    	}
    	//printf("\n");
  	}
}

void backtrack(adjMatrix *adj, int source, int dest) 
{
	int k = adj->Y[source][dest];
	
	if (source == dest) {
		printf("I%d ",source);
		return;
	}
	if (adj->Y[source][dest] == -1) {
        printf("I%dP%dS|sb  ",source,dest);
        return;
    }
    backtrack(adj,source,k);
    printf(" %d ",dest);
}

void traverseMatrix(adjMatrix *adj) {
	int source, sink; 
	
	printf("\n\ndߥGI̵u|\nI(0hXd) => ");
    scanf("%d",&source);
    if (source == 0) return;
    printf("I(0hXd) => ");
    scanf("%d",&sink);
    if (sink == 0) return;
	
	printf("̵u|G");
	backtrack(adj,source,sink);
	printf("\b\b  ");
}

void freeMemory(adjMatrix *adj) {
	int i, N = adj->size;
	
	for (i = 0; i <= N; i++) { 
		free(adj->A[i]); 
		free(adj->Y[i]); 
	} 
	free(adj->A); 
	free(adj->Y);
}

int main() 
{
	printf("\n***  all-pairs shortest-path D ***");
	
	adjMatrix adj = init();			/* ŪJɡB]w۾Fx}AçƵc@l */
  	floydWarshall(&adj);
  	printMatrix(&adj);
  	traverseMatrix(&adj);
  	freeMemory(&adj);
  	
  	return 0; 
}
